.nolist
    include     \masm32\include\masm32rt.inc    ; defaults to .386
    .586
    include     timers.asm      ; requires a pentium

    LOOPCOUNT equ 1000;00;0

    PROCS TEXTEQU <szCmpix,szCmpixx,szCmpix6>
    RepCnt = 40000
    LastString= RepCnt*26-1
    SIZES1 TEXTEQU <0,1,2,100,LastString>	; tests for matching strings
    SIZES2 TEXTEQU <1,2,3,100,LastString> ; tests for mis-matched strings

.listall
    %FOR proc,<PROCS>
        proc proto :DWORD,:DWORD,:DWORD
    ENDM

    MAXWIDTH  equ 20
    HDRWIDTH  equ 9
    COLWIDTH  equ 10

    .data
    align 16
    tbl \
      db   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15
      db  16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31
      db  32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47
      db  48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63
      db  64, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111
      db 112,113,114,115,116,117,118,119,120,121,122, 91, 92, 93, 94, 95
      db  96, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111
      db 112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127
      db 128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143
      db 144,145,146,147,148,149,150,151,152,153,154,155,156,156,158,159
      db 160,161,162,163,164,165,166,167,168,169,170,171,172,173,173,175
      db 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
      db 192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207
      db 208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223
      db 224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239
      db 240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255

	; matching strings, up to 104 characters, mismatch at 105
	; for mismatch test, will changed character at test location at run time. 
align 16
	strm1x db "AbCdEfGhIjKlMnOpQrStUvWxYzAbCdEfGhIjKlMnOpQrStUvWxYz","."  ; 26,000 characters
align 16
	strm2x db "aBcDeFgHiJkLmNoPqRsTuVwXyZaBcDeFgHiJkLmNoPqRsTuVwXyZ",255
align 4
	OldVal db 0,0,0,0
	OldLoc dd 0

HeapHandle  dd 0  ; Handle to extra memory for test strings
HeapStart dd ?      ; start of extra memory for strings
	
Str1Addr dd ?	; location of first test string
Str2Addr dd ?	; location of second test string
.code

align 16

sxFld proc DDpointer:DWORD, rvstring:DWORD, DDwidth:DWORD, DDalign:DWORD
    .if DDalign == 0                    ; align left?
        invoke szLeft,DDpointer,rvstring,DDwidth
        invoke szLen,rvstring
        mov edx,rvstring
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+eax],32
        inc eax
        jmp @B
    @@: mov byte ptr [edx+eax],0
    .elseif DDalign == 1                ; align right?
        invoke szLen,DDpointer
        mov edx,rvstring
        xor ecx,ecx
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+ecx],32
        inc eax
        inc ecx
        jmp @B
    @@: add edx,ecx
        invoke szLeft,DDpointer,edx,DDwidth
    .endif
    ret 4*4

sxFld endp

fld$ MACRO DDpointer,DDwidth,DDalign:=<0>       ; Default is align left
    LOCAL rvstring
    .data
        rvstring db MAXWIDTH+4 dup (0)
        align 16
    .code
    invoke sxFld,reparg(DDpointer),ADDR rvstring,DDwidth,DDalign
    EXITM <ADDR rvstring>
ENDM
.code
SetString proc SLen:DWORD,SLoc:DWORD	; make a mismatch at character SLoc
	push edx
	push eax
	mov edx,SLoc
	add edx,SLen
	dec edx
	mov al,[edx]
	mov OldVal,al
	mov OldLoc,edx
	mov [edx],byte ptr 0		; create mis-match	
	pop eax
	pop edx
	ret
SetString EndP	
ResString proc	; restore string
	push edx
	push eax
	mov edx,OldLoc
	mov al,OldVal
	mov [edx],al		; remove terminator and restore to original	
	pop eax
	pop edx
	ret
ResString EndP

;----------------------------------------------
align 16
start:
    
    invoke GetProcessHeap
    mov HeapHandle,eax
    mov ecx,2*RepCnt*26+20
    invoke HeapAlloc,EAX,HEAP_GENERATE_EXCEPTIONS,ecx
    mov HeapStart,eax    ; start of heap
    mov Str1Addr,eax
    add eax,RepCnt*26+10
    mov Str2Addr,eax

	push esi
	push edi
	mov edi,Str1Addr
	mov edx,RepCnt

lp1:
	mov esi,offset strm1x
	mov ecx,26
	rep movsb
	dec edx
	jnz lp1
	mov [edi],byte ptr 111
			
	mov edi,Str2Addr
	mov edx,RepCnt
lp2:
	mov esi,offset strm2x
	mov ecx,26
	rep movsb
	dec edx
	jnz lp2
	mov [edi],byte ptr 255	; insure mismatch
	
	pop edi
	pop esi
	
	print chr$("first 225 characters of test strings",13,10,13,10)
	print chr$("Str1 = ")
	
	mov ecx,Str1Addr
    invoke SetString,225,ecx  ; make mismatch at character defined in sizes2
    mov ecx,Str1Addr
    print ecx
    invoke ResString	

	print chr$(13,10,13,10,"Str2 = ")
	mov ecx,Str2Addr
    invoke SetString,225,ecx  ; make mismatch at character defined in sizes2
    mov ecx,Str2Addr
    print ecx
    invoke ResString
    print chr$(13,10,13,10)	

;  ---------------------First test matching strings-----------------------------------------------
    print chr$("Test routines for correctness:",13,10)
    print chr$("Matching Strings at various lengths, answer should be zero:",13,10)
    print fld$(chr$("test size"),HDRWIDTH)
    %FOR len,<SIZES1>
        print fld$(sstr$(&len&),COLWIDTH,1)
    ENDM
    print chr$(13,10)
    print fld$(chr$("=========="),HDRWIDTH)
    %FOR len,<SIZES1>
        print fld$(" =========",COLWIDTH)
    ENDM
    print chr$(13,10)
;    %FOR extra,<0,1,2,3>
;        print chr$("&extra& byte misalignment",13,10)
        %FOR prok,<PROCS>
            print fld$(chr$("&prok&"),HDRWIDTH)
            %FOR len,<SIZES1>
            	mov ecx,Str1Addr
            	mov edx,Str2Addr
                invoke prok,ecx,edx, &len&
                print fld$(sstr$(eax),COLWIDTH,1)
            ENDM
            print chr$(13,10)
        ENDM
;    ENDM
;
    print chr$(13,10)
    print chr$("Execution Cycles:",13,10)
    print fld$(chr$("test size"),HDRWIDTH)
    %FOR len,<SIZES1>
        print fld$(sstr$(&len&),COLWIDTH,1)
    ENDM
    print chr$(13,10)

    print fld$(chr$("=========="),HDRWIDTH)
    %FOR len,<SIZES1>
        print fld$(" =========",COLWIDTH)
    ENDM
    print chr$(13,10)

;    %FOR extra,<0,1,2,3>
;        print chr$(13,10)
;        print chr$("&extra& byte misalignment",13,10)
       %FOR prok,<PROCS>
            print fld$(chr$("&prok&"),HDRWIDTH)
            %FOR len,<SIZES1>
                counter_begin LOOPCOUNT, REALTIME_PRIORITY_CLASS
            	mov ecx,Str1Addr
            	mov edx,Str2Addr
                invoke prok,ecx,edx, &len&
                counter_end
                mov ebx,eax
                print fld$(sstr$(ebx),COLWIDTH,1)
            ENDM
        print chr$(13,10)
        ENDM
;    ENDM

jmp alldone	; skip second test on these long strings

;  ---------------------Now test mismatching strings-----------------------------------------------
	print chr$(13,10,13,10)
    print chr$("Test routines for correctness:",13,10)
    print chr$("Mis-matching Strings, mismatch at character:",13,10)
    print fld$(chr$(" "),HDRWIDTH)
    %FOR len,<SIZES2>
        print fld$(sstr$(&len&),COLWIDTH,1)
    ENDM
    print chr$(13,10)
    print fld$(chr$("=========="),HDRWIDTH)
    %FOR len,<SIZES2>
        print fld$(" =========",COLWIDTH)
    ENDM
    print chr$(13,10)
;    %FOR extra,<0,1,2,3>
;        print chr$("&extra& byte misalignment",13,10)
        %FOR prok,<PROCS>
            print fld$(chr$("&prok&"),HDRWIDTH)
            %FOR len,<SIZES2>
            	mov ecx,Str2Addr
	            invoke SetString,len,ecx  ; make mismatch at character defined in sizes2	
            	mov ecx,Str1Addr
            	mov edx,Str2Addr
                invoke prok,ecx,edx, &len&
		        invoke ResString				; restore the test string
                print fld$(sstr$(eax),COLWIDTH,1)
            ENDM
            print chr$(13,10)
        ENDM
;    ENDM
;
    print chr$(13,10)
    print chr$("Execution Cycles:",13,10)
    print fld$(chr$("miss at "),HDRWIDTH)
    %FOR len,<SIZES2>
        print fld$(sstr$(&len&),COLWIDTH,1)
    ENDM
    print chr$(13,10)

    print fld$(chr$("=========="),HDRWIDTH)
    %FOR len,<SIZES2>
        print fld$(" =========",COLWIDTH)
    ENDM
    print chr$(13,10)

;    %FOR extra,<0,1,2,3>
;        print chr$(13,10)
;        print chr$("&extra& byte misalignment",13,10)
       %FOR prok,<PROCS>
            print fld$(chr$("&prok&"),HDRWIDTH)
            %FOR len,<SIZES2>
            	mov ecx,Str2Addr
	            invoke SetString,len,ecx  ; make mismatch at character defined in sizes2	
                counter_begin LOOPCOUNT, REALTIME_PRIORITY_CLASS
            	mov ecx,Str1Addr
            	mov edx,Str2Addr
                invoke prok,ecx,edx, &len&
                counter_end
		        invoke ResString
                mov ebx,eax
                print fld$(sstr$(ebx),COLWIDTH,1)
            ENDM
        print chr$(13,10)
        ENDM
;    ENDM






alldone:
    invoke HeapFree, HeapHandle,NULL,HeapStart
    mov   eax,input(13,10,"Press enter to exit...")
    exit

; --------------------- Routines under test ---------------------------------------------


; 

align 4

szCmpix proc src:DWORD,dst:DWORD,ln:DWORD

  ; -----------------------------------------------------------
  ; algorithm compares any two byte sequences CASE INSENSITIVE
  ; and returns zero if they are identical or the character
  ; count where the two byte sequences mismatch.
  ; -----------------------------------------------------------

    push ebx
    push esi
    push edi

    sub eax, eax
    sub edx, edx

    mov ebx, OFFSET tbl  ; table base address
    mov esi, src                    ; 1st string in ESI
    mov edi, dst                    ; 2nd string in EDI
    mov ecx, ln

    push ebp
    mov ebp, -1

  align 4
  @@:
    add ebp, 1
    mov al, [esi+ebp]               ; get 1st byte
    xlatb                           ; replace it with byte in table
    mov dl, al                      ; store it in DL
    mov al, [edi+ebp]               ; get 2nd byte
    xlatb                           ; replace it with byte in table
    sub al, dl                      ; if bytes are the same
    jnz @F                          ; exit the loop
    cmp ebp, ecx                    ; exit on length
    jl @B
  @@:

    mov ecx, ebp
    pop ebp

    cmp ecx, ln
    jnz @F
    xor eax, eax
    jmp quit
  @@:
    lea eax, [ecx+1]

  quit:

    pop edi
    pop esi
    pop ebx

    ret

szCmpix endp

align 16
szCmpixx proc src:DWORD,dst:DWORD,ln:DWORD

    push ebx
    push esi
    push edi

    mov esi, src
    mov edi, dst
    mov eax, -1

  align 4
  @@:
    add eax, 1
    movzx edx, BYTE PTR [esi+eax]
    mov cl, [edx+tbl]
    movzx ebx, BYTE PTR [edi+eax]
    cmp cl, [ebx+tbl]
    jne miss
    cmp eax, ln
    jne @B

    sub eax, eax
    jmp quit

  miss:
    add eax, 1

  quit:
    pop edi
    pop esi
    pop ebx

    ret

szCmpixx endp


align 16
szCmpix6 proc src:DWORD,dst:DWORD,ln:DWORD

    xor eax, eax
	cmp ln,eax
	je	wrap 
	
    push esi
    push edi

    xor edx,edx

    mov esi, src                    ; 1st string in ESI
    mov edi, dst                    ; 2nd string in EDI
    mov ecx, ln
	align 16
@@:
    movzx eax, byte ptr [esi]               ; get 1st byte
    cmp eax,41h ;'A'
    jb noupper
    cmp eax,5ah ;'Z'
    ja noupper
    or eax,20h
    noupper:
    movzx edx, byte ptr [edi]               ; get 2nd byte
    cmp edx,41h ;'A'
    jb noupper2
    cmp edx,5ah ;'Z'
    ja noupper2
    or edx,20h
    noupper2:
    cmp eax, edx                    ; if bytes are the same
    jne done                          ; exit the loop

    sub ecx,1
    jz done2

    movzx eax, byte ptr [esi+1]               ; get 1st byte
    cmp eax,41h ;'A'
    jb noupper3
    cmp eax,5ah ;'Z'
    ja noupper3
    or eax,20h
    noupper3:
    movzx edx, byte ptr [edi+1]               ; get 2nd byte
    cmp edx,41h ;'A'
    jb noupper4
    cmp edx,5ah ;'Z'
    ja noupper4
    or edx,20h
    noupper4:
    cmp eax, edx                    ; if bytes are the same
    jne done                          ; exit the loop

	sub ecx,1    
    jz done2			; no more to do
    add esi,2
    add edi,2
    jmp @b

done2:	; here if out of characters to test, return zero
	xor eax,eax
	jmp quit

done:	; here if mismatch
	mov eax,ln
	sub eax,ecx
	add eax,1
	
quit:
    pop edi
    pop esi
wrap:
    ret

szCmpix6 endp


end start
